<template>
  <div id="project">
    <CoscineHeadline :headline="$t('page.listProjects.title', 0)" />
    <div class="list">
      <b-card-group id="card-deck" deck>
        <CoscineCard
          :title="$t('page.listProjects.addProject')"
          type="create"
          :to="toCreateProject()"
          @open-card="openCreateProject($event)"
        />
        <CoscineCard
          v-for="(project, index) in projects"
          :key="index"
          :title="project.displayName"
          type="project"
          :to="toProject(project)"
          @open-card="openProject($event, project)"
        />
      </b-card-group>
    </div>
  </div>
</template>

<script lang="ts">
import type { RouteLocationRaw } from "vue-router";
import type { ProjectDto } from "@coscine/api-client/dist/types/Coscine.Api";

// import the store for current module
import useProjectStore from "../store";
import useNotificationStore from "@/store/notification";
import { removeQueryParameterFromUrl } from "@/router";
import useUserStore from "@/modules/user/store";

export default defineComponent({
  setup() {
    const projectStore = useProjectStore();

    return { projectStore };
  },

  computed: {
    projects(): ProjectDto[] | null {
      return this.projectStore.topLevelProjects;
    },
  },

  created() {
    // handle possible invitation token
    this.projectStore.resolveProjectInvitation();

    // Handle possible merge result
    this.checkForMerge();
  },

  methods: {
    toCreateProject(): RouteLocationRaw {
      const route = { name: "create-project" } as RouteLocationRaw;
      return route;
    },
    toProject(project: ProjectDto): RouteLocationRaw {
      const route = {
        name: "project-page",
        params: { slug: project.slug },
      } as RouteLocationRaw;
      return route;
    },
    openCreateProject(to: RouteLocationRaw) {
      // Set current project slug to null
      this.projectStore.currentSlug = null;
      this.$router.push(to);
    },
    openProject(to: RouteLocationRaw, project: ProjectDto) {
      if (project.slug) {
        this.projectStore.currentSlug = project.slug;
        this.$router.push(to);
      } else {
        console.error(
          `Slug for ${project.displayName} is possibly undefined...`,
        );
      }
    },
    checkForMerge() {
      const mergeExternalQueryParameter = "merged_with";
      const mergeId =
        this.$router.currentRoute.value.query[mergeExternalQueryParameter];

      if (mergeId) {
        const userStore = useUserStore();
        const notificationStore = useNotificationStore();

        const identity = userStore.user?.identities?.find(
          (x) => x.id === mergeId,
        );

        if (identity) {
          notificationStore.postNotification({
            title: this.$t("page.project.toast.merge.success.title").toString(),
            body: this.$t("page.project.toast.merge.success.body", {
              externalName: identity.displayName,
            }).toString(),
          });
        } else {
          notificationStore.postNotification({
            title: this.$t("page.project.toast.merge.failure.title").toString(),
            body: this.$t("page.project.toast.merge.failure.body", {
              externalId: mergeId,
            }).toString(),
            variant: "danger",
          });
        }

        removeQueryParameterFromUrl(
          this.$router.currentRoute.value,
          mergeExternalQueryParameter,
        );
      }
    },
  },
});
</script>
